Unit AV13C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAV10_p;

procedure AV13C(N :Integer; CA :Complex; var CX :Array of Complex;
                INCX :Integer; var CY :Array of Complex;
                INCY :Integer; var IERR :Integer);

implementation

procedure AV13C(N :Integer; CA :Complex; var CX :Array of Complex;
                INCX :Integer; var CY :Array of Complex;
                INCY :Integer; var IERR :Integer);
var
I,IX,IY,M,MP1 :Integer;
X :Real;
label
_10,_20,_30,_40,_50,_60,_80;
begin
IERR  := 0;
if ( N  <=  0 ) 
 then goto _60;
if ( Cabs(CA) = 0.0 ) 
 then goto _80;
X  := 0.0;
if ( INCX  =  1 ) and (  INCY  =  1 ) 
 then goto _20;
IX  := 1 + ((INCX - Abs(INCX)) div 2)*(1 - N);
IY  := 1 + ((INCY - Abs(INCY)) div 2)*(1 - N);
for I:=1 to N do
 begin
  CY[IY-1] := AddC(CY[IY-1],MulC(CA,CX[IX-1]));
  IX  := IX + INCX;
  IY  := IY + INCY;
_10:
 end;
goto _80;
_20:
M  := ((N) Mod (4));
if ( M  =  0 ) 
 then goto _40;
for I:=1 to M do
 begin
  CY[I-1] := AddC(CY[I-1],MulC(CA,CX[I-1]));
_30:
 end;
if ( N  <  4 ) 
 then goto _80;
_40:
MP1  := M + 1;
I := MP1;
while ( I<=N ) do
 begin
  CY[I-1] := AddC(CY[I-1],MulC(CA,CX[I-1]));
  CY[I+0] := AddC(CY[I+0],MulC(CA,CX[I+0]));
  CY[I+1] := AddC(CY[I+1],MulC(CA,CX[I+1]));
  CY[I+2] := AddC(CY[I+2],MulC(CA,CX[I+2]));
_50:
  inc(I,4);
 end;
goto _80;
_60:
IERR  := 65;
UTAV10(IERR,12);
goto _80;
_80:
end;

end.
